var EHexDialogUI = {
	
	/*
	 * WaitDialog
	 */
	defaultMessage : 'Bitte warten...',
	
	waitDialog : $('#waitDialog'),
	
	showWait : function(message) {
		if (message == null || message == '') {
			message = EHexDialogUI.defaultMessage;
		}
		EHexDialogUI.waitDialog.find('.wait-dialog-message').text(message);
		EHexDialogUI.waitDialog.modal();
	},
	
	hideWait : function() {
		EHexDialogUI.waitDialog.modal('hide');
	},
	
	/*
	 * ConfirmDialog
	 */
	confirmDialog : $('#confirmDialog'),
	
	confirm : function(message, callback) {
		message = message.replace(/\n/g,'<br/>');
		EHexDialogUI.confirmDialog.find('.modal-body').html(message);
		EHexDialogUI.confirmDialog.find('.modal-confirm').off('click');
		EHexDialogUI.confirmDialog.find('.modal-confirm').one('click', function() {
			EHexDialogUI.confirmDialog.modal('hide');
			callback(true);			
		});
		EHexDialogUI.confirmDialog.modal('show');
		
		var dialogHeight = EHexDialogUI.confirmDialog.outerHeight();
		var headerHeight = EHexDialogUI.confirmDialog.find('.modal-header').outerHeight();
		var footerHeight = EHexDialogUI.confirmDialog.find('.modal-footer').outerHeight();
		EHexDialogUI.confirmDialog.find('.modal-body').css('max-height', dialogHeight - headerHeight - footerHeight);
		EHexDialogUI.confirmDialog.find('.modal-body').scrollTop(0);
	},
	
	/*
	 * MessageDialog
	 */
	messageDialog : $('#messageDialog'),
	
	message : function(title, message) {
		EHexDialogUI.messageDialog.find('.modal-header-message').html(title != null && title != '' ? title : 'Hinweis:');
		
		message = message.replace(/\n/g,'<br/>');
		EHexDialogUI.messageDialog.find('.modal-body').html(message);
		
		EHexDialogUI.messageDialog.modal('show');
		
		var dialogHeight = EHexDialogUI.messageDialog.outerHeight();
		var headerHeight = EHexDialogUI.messageDialog.find('.modal-header').outerHeight();
		var footerHeight = EHexDialogUI.messageDialog.find('.modal-footer').outerHeight();
		EHexDialogUI.messageDialog.find('.modal-body').css('max-height', dialogHeight - headerHeight - footerHeight);
		EHexDialogUI.messageDialog.find('.modal-body').scrollTop(0);
	},
	
};
