	(function( $ ) {
 
    $.fn.renamable = function( options ) {
 
        var settings = $.extend({
            // No default options.
        }, options );
        
        var backup = null;
        var elmement = null;
        var value = null;
        
        var rename = function(srcElement) {
        	if (!srcElement.hasClass('protected-on') && srcElement.find('.renaming').length === 0) {
        		element = srcElement;
        		backup = srcElement.text();        		
        		srcElement.html('<input class="renaming" value="' + srcElement.text() + '" />');
        		srcElement.find('.renaming')
        			.on('blur', onRename)
        			.on('keydown', onKeyDownHandler)
        			.focus().select();
        	}
        };
        
        var onCanceled = function(event) {
        	done(backup);
        };
        
        var onRename = function(event) {
        	if (element != null) {
	        	value = $(event.target).val();
	        	if (value == null || value == '') {
	        		done(backup);
	        	} else if (value != backup && typeof(settings.renaming) === 'function') {
	        		settings.renaming(backup, value, onSuccess, onError);
	        	} else {
	        		done(value);
	        	}
        	}
        };
        
        var onSuccess = function(data, textStatus, jqXHR)  {
        	if (element != null) {
	        	if (typeof(settings.success) === 'function') {
	        		settings.success(data, textStatus, jqXHR);
	        	}
	        	done(value);
        	}        	
        };
        
        var onError = function(jqXHR, textStatus, errorThrown)  {
        	if (typeof(settings.error) === 'function') {
        		settings.error(jqXHR, textStatus, errorThrown);
        	}
        	if (element != null) {
        		element.find('.renaming').focus().select();
        	}
        };
        
        var done = function(value) {
        	if (element != null) {
        		element.html(value);
        	}
        	element = null;
        	value = null;
        	backup = null;
        };
        
        var onKeyDownHandler = function(event) {
			switch (event.which) {
			case 27: // ESC
				onCanceled(event);
				break;
			case 13: // ENTER
				onRename(event);
				break;
			default:
				break;
			}
		};
        
        this.dblclick(function(event) {
        	rename($(event.target));
        });
        
        return this;
 
    };
 
}( jQuery ));