function PuppetryBackupUI() {
	this._header = '<span class="font-50">Datensicherung</span>';
	this._contentId = '.backup-content';
	this._menuItemId = '.admin-backup';
}
		
PuppetryBackupUI.prototype.initUI = function() {
	var self = this;
	
	$('.backupUpload').dropzone({
		url : function (files) {
			return '../config/restore';
		},
		method : 'put',
		clickable : '.backupUpload',
		previewTemplate : '<div style="display: none"></div>',
		acceptedFiles: '.puppetbox',
		autoProcessQueue: false,
		addedfile: function(file) {
			var myDropzone = this;
			EHexDialogUI.confirm(
				'Sind Sie sicher, dass Sie das Backup ' + "„" + file.name + "“" + ' einspielen wollen?<br/>Beim Einspielen des Backups werden die Dienste der Anwendung neugestartet.', 
				function() {
					myDropzone.processQueue();
				}
			);
			
		},
		success: function(file, response) {
			EHexDialogUI.message('Wiederherstellung erfolgreich!', 'Das Backup ' + "„" + file.name + "“" + ' wurde eingespielt. Es kann einen Moment dauern bis alle Dienste wieder bereitstehen.');
		},
		error: function(data, txtStatus, jqXHR) {
			EHexServiceUtil.onErrorHandler(txtStatus, txtStatus);
		}
	});

	$('.mergeUpload').dropzone({
		url : function (files) {
			return '../config/merge';
		},
		method : 'put',
		clickable : '.mergeUpload',
		previewTemplate : '<div style="display: none"></div>',
		acceptedFiles: '.puppetbox',
		autoProcessQueue: false,
		addedfile: function(file) {
			var myDropzone = this;
			EHexDialogUI.confirm(
					'Sind Sie sicher, dass Sie die Konfiguration ' + "„" + file.name + "“" + ' einspielen wollen?<br/>Beim automatischen Zusammenführen der Konfiguration kann es passieren, das Daten verloren gehen. Nach dem Einspielen werden die Dienste der Anwendung neugestartet.', 
					function() {
						myDropzone.processQueue();
					}
			);
			
		},
		success: function(file, response) {
			EHexDialogUI.message('Zusammenführung erfolgreich!', 'Die Konfiguration ' + "„" + file.name + "“" + ' wurde eingespielt. Es kann einen Moment dauern bis alle Dienste wieder alle bereitstehen.');
		},
		error: function(data, txtStatus, jqXHR) {
			EHexServiceUtil.onErrorHandler(txtStatus, txtStatus);
		}
	});
	
};

PuppetryBackupUI.prototype.showUI = function(source, detail) {
	var self = this;
	
	if ($('#wrapper').hasClass('admin-mode')) {
		$('.admin-mode > .header').html(this._header);
		$('.admin-content').hide();
	} else {
		$('.live-mode > .header').html(this._header);
		$('.live-content').hide();
	}
	$(this._contentId).show();
};
		
PuppetryBackupUI.prototype.downloadConfig = function(type) {
	PuppetryBackupService.downloadBackup(
			function(data, textStatus, jqXHR) {},
			EHexServiceUtil.onErrorHandler
		);
};

PuppetryBackupUI.prototype.resetConfig = function(type) {
	PuppetryBackupService.resetSystem(
			function(data, textStatus, jqXHR) {
				EHexDialogUI.message('Wiederherstellung erfolgreich!', 'Das System wurde auf den Ausllieferungszustand zurückgesetzt. Es kann einen Moment dauern bis alle Dienste wieder alle bereitstehen.');
			},
			EHexServiceUtil.onErrorHandler
	);
};

