var PuppetryClientService = {
		
	getClients : function(success, error, context) {
		var requestURL = '../client';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	newClient : function(success, error, context) {
		var requestURL = '../client/new';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getClient : function(id, success, error, context) {
		var requestURL = '../client/' + id;

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	addClient : function(client, success, error, context) {		
		var requestURL = '../client';
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(client),			
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	updateClient : function(client, success, error, context) {
		var requestURL = '../client/' + encodeURIComponent(client.id);
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(client),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	removeClient : function(client, success, error, context) {		
		var requestURL = '../client/' + encodeURIComponent(client.id);
		
		$.ajax({
			url : requestURL,
			method: 'DELETE',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	resolveClientReferences : function(client, success, error, context) {
		var requestURL = '../client/' + encodeURIComponent(client.id) + '/references';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	renameClient : function(id, newClient, success, error, context) {		
		var requestURL = '../client/' + encodeURIComponent(id) + '/label/' + encodeURIComponent(newClient);
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	validateClient : function(client, success, error, context) {
		var requestURL = '../client/warnings';
		
		$.ajax({
			url : requestURL,
			method: 'POST',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(client),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
};