var PuppetryClientTerminalsService = {
		
	getTerminals : function(clientId, success, error, context) {
		var requestURL = '../client/' + encodeURIComponent(clientId) + '/terminal';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000, 
			context : context
		});
	},
	
	newTerminal : function(clientId, success, error, context) {
		var requestURL = '../client/' + encodeURIComponent(clientId) + '/terminal/new';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getTerminal : function(clientId, terminalId, success, error, context) {
		var requestURL = '../client/' + encodeURIComponent(clientId) + '/terminal/' + encodeURIComponent(terminalId);

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	
	getPrototypeTerminal : function(clientId, ctId, success, error, context) {
		var requestURL = '../client/' + encodeURIComponent(clientId) + '/terminal/prototype/' + encodeURIComponent(ctId);
		
		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	
	addTerminal : function(clientId, terminal, success, error, context) {		
		var requestURL = '../client/' + encodeURIComponent(clientId) + '/terminal';
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(terminal),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	updateTerminal : function(clientId, terminal, success, error, context) {		
		var requestURL = '../client/' + encodeURIComponent(clientId) + '/terminal/' + encodeURIComponent(terminal.id);
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(terminal),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	renameTerminal : function(clientId, terminalId, newName, success, error, context) {		
		var requestURL = '../client/' + encodeURIComponent(clientId) + '/terminal/' + encodeURIComponent(terminalId) + '/label/' + encodeURIComponent(newName);
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	removeTerminal : function(clientId, terminal, success, error, context) {		
		var requestURL = '../client/' + encodeURIComponent(clientId) + '/terminal/' + encodeURIComponent(terminal.id);
		
		$.ajax({
			url : requestURL,
			method: 'DELETE',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	resolveTerminalReferences : function(clientId, terminal, success, error, context) {
		var requestURL = '../client/' + encodeURIComponent(clientId) + '/terminal/' + encodeURIComponent(terminal.id) + '/references';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	validateTerminal : function(clientId, terminal, success, error, context) {
		var requestURL = '../client/' + encodeURIComponent(clientId) + '/terminal/warnings';
		
		$.ajax({
			url : requestURL,
			method: 'POST',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(terminal),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
};