var PuppetryConnectorService = {
		
	getAuthenticationMechanisms : function(success, error, context) {
		var requestURL = '../connector/authentication';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getEventClientBehaviour : function(success, error, context) {
		var requestURL = '../connector/eventclientbehaviour';
		
		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getConnector : function(success, error, context) {
		var requestURL = '../connector';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	setOn : function(success, error, context) {
		var requestURL = '../connector/active';

		$.ajax({
			url : requestURL,
			method: 'PUT',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	setOff : function(success, error, context) {
		var requestURL = '../connector/active';

		$.ajax({
			url : requestURL,
			method: 'DELETE',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	setOnline : function(success, error, context) {
		var requestURL = '../connector/online';

		$.ajax({
			url : requestURL,
			method: 'PUT',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	setOffline : function(success, error, context) {
		var requestURL = '../connector/online';

		$.ajax({
			url : requestURL,
			method: 'DELETE',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	setEventsActive : function(success, error, context) {
		var requestURL = '../connector/event/active';
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	setEventsInactive : function(success, error, context) {
		var requestURL = '../connector/event/active';
		
		$.ajax({
			url : requestURL,
			method: 'DELETE',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getEvents : function(success, error, context) {
		var requestURL = '../connector/event';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getEventParameters : function(topic, success, error, context) {
		var requestURL = '../connector/event/' + encodeURIComponent(topic) + '/params';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	sendEvent : function(topic, parameters, success, error, context) {
		var requestURL = '../connector/event/' + encodeURIComponent(topic);

		$.ajax({
			url : requestURL,
			method: 'PUT',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(parameters),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getEventSubscriptions : function(success, error, context) {
		var requestURL = '../connector/event/subscription';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getSubscriptions : function(success, error, context) {
		var requestURL = '../connector/event/subscription';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	removeSubscription: function(subscription, success, error, context) {		
		var requestURL = '../connector/event/subscription/' + encodeURIComponent(subscription.id);
		
		$.ajax({
			url : requestURL,
			method: 'DELETE',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	setSettings : function(settings, success, error, context) {
		var requestURL = '../connector/settings';
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(settings),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getTLSCert : function(context) {
		var requestURL = '../connector/tls/cert';
		window.open(requestURL,'_blank');
	},
	
	getSDSStatus : function(success, error, context) {
		var requestURL = '../connector/sdsstatus';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
};