function PuppetryConnectorStatusUI() {
	this._header = '<span class="font-20">Konnektor &lt; </span><span class="font-50">Status</span>';
	this._contentId = '.connector-status-content';
	this._menuItemId = '.common-connector-status';
}
		
PuppetryConnectorStatusUI.prototype.initUI = function() {
	var self = this;
	
	$('.connector-status-content .toggle[for="connector-status-on"]').click(function() {
		var checkBoxes = $("#connector-status-on");		
		var onBefore = checkBoxes.prop("checked");
		
		if(onBefore) {
			EHexDialogUI.showWait('Der Konnektor wird gestoppt...');
			PuppetryConnectorService.setOff(
				function(data, textStatus, jqXHR ) {
					checkBoxes.prop("checked", false);
					self.validateOnState();

					EHexDialogUI.hideWait();
				}, 
				EHexServiceUtil.onErrorHandler
			);
		}
		else {
			EHexDialogUI.showWait('Der Konnektor wird gestartet...');
			PuppetryConnectorService.setOn(
				function(data, textStatus, jqXHR ) {
					checkBoxes.prop("checked", true);
					self.validateOnState();
					
					EHexDialogUI.hideWait();
				}, 
				EHexServiceUtil.onErrorHandler
			);
		}
		
		return false;
	});
	
	
	$('.connector-status-content .toggle[for="connector-status-online"]').click(function() {
			
		var checkBoxes = $("#connector-status-online");
		
		if(!checkBoxes.is("[disabled]")) {
			var onlineBefore = checkBoxes.prop("checked");
			
			if(onlineBefore) {
				EHexDialogUI.showWait('Die Online-Verbindung wird getrennt...');
				PuppetryConnectorService.setOffline(
					function(data, textStatus, jqXHR ) {
						checkBoxes.prop("checked", false);
						EHexDialogUI.hideWait();
					}, 
					EHexServiceUtil.onErrorHandler
				);
			}
			else {
				EHexDialogUI.showWait('Die Online-Verbindung wird hergestellt...');
				PuppetryConnectorService.setOnline(
					function(data, textStatus, jqXHR ) {
						checkBoxes.prop("checked", true);
						EHexDialogUI.hideWait();
					}, 
					EHexServiceUtil.onErrorHandler
				);
			}
		}
		
		return false;
	});
	
};

PuppetryConnectorStatusUI.prototype.showUI = function() {
	var self = this;
	
	if ($('#wrapper').hasClass('admin-mode')) {
		$('.admin-mode > .header').html(this._header);
		$('.admin-content').hide();
	} else {
		$('.live-mode > .header').html(this._header);
		$('.live-content').hide();
	}
	
	var detailHeight = $(window).height() - $('.navbar.navbar-default').height();
	$(this._contentId).css('min-height', detailHeight);			
	$(this._contentId).show();						
	
	PuppetryConnectorService.getConnector(
			function(data, textStatus, jqXHR ) {
				$("#connector-status-on").prop("checked", data.on);
				$("#connector-status-online").prop("checked", data.online);
				self.validateOnState()
			}, 
			EHexServiceUtil.onErrorHandler
		);
};
		
PuppetryConnectorStatusUI.prototype.validateOnState = function() {

	var on = $("#connector-status-on").prop("checked");
	if (on === false) {							
		var online = $("#connector-status-online").prop("checked");
		
		if (online === true) {
			$("#connector-status-online").addClass('wasOnline');
			$("#connector-status-online").prop("checked", false);
		}
		else {
			$("#connector-status-online").removeClass('wasOnline');
		}
		$('#connector-status-online').attr('disabled', 'disabled');
	} else {
		$('#connector-status-online').removeAttr('disabled');
		
		if($('#connector-status-online.wasOnline').length > 0) {
			$("#connector-status-online").prop("checked", true);
			$("#connector-status-online").removeClass('wasOnline');
		}
	}
};