var PuppetryEHCService = {
		
	getEHCs : function(success, error, context) {
		var requestURL = '../insuredcard';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	newEHC : function(success, error, context) {
		var requestURL = '../insuredcard/new';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getEHC : function(cardId, success, error, context) {
		var requestURL = '../insuredcard/' + cardId;

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getEHCReferences : function(ehc, success, error, context) {
		var requestURL = '../insuredcard/' + ehc.id + '/references';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	addEHC : function(ehc, success, error, context) {
		var requestURL = '../insuredcard';
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(ehc),			
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	updateEHC : function(ehc, success, error, context) {		
		var requestURL = '../insuredcard/' + encodeURIComponent(ehc.id);
	
		$.ajax({
			url : requestURL,
			method: 'PUT',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(ehc),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	cloneEHC : function(ehc, success, error, context) {
		var requestURL = '../insuredcard/' + encodeURIComponent(ehc.id) + '/clone';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	renameEHC : function(id, newLabel, success, error, context) {		
		var requestURL = '../insuredcard/' + encodeURIComponent(id) +'/label/' + encodeURIComponent(newLabel);
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	removeEHC : function(ehc, success, error, context, force) {		
		var requestURL = '../insuredcard/' + encodeURIComponent(ehc.id);
		if (force === true) {
			requestURL += '?force=true';
		}
		
		$.ajax({
			url : requestURL,
			method: 'DELETE',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	validateEHC : function(ehc, success, error, context) {
		var requestURL = '../insuredcard/warnings';
		
		$.ajax({
			url : requestURL,
			method: 'POST',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(ehc),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getPNs : function(success, error, context) {
		var requestURL = '../insuredcard/pn';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getGenders : function(success, error, context) {
		var requestURL = '../insuredcard/gender';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getInsuranceTypes : function(success, error, context) {
		var requestURL = '../insuredcard/insurancetype';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getSchemaVersions : function(success, error, context) {
		var requestURL = '../insuredcard/schemaversion';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
};