var PuppetryClientServiceHookService = {

	getServiceHooks : function(clientId, success, error, context) {
		var requestURL = '../runtime/client/' + encodeURIComponent(clientId) + '/servicehook';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000, 
			context : context
		});
	},
	
	newServiceHook : function(clientId, success, error, context) {
		var requestURL = '../runtime/client/' + encodeURIComponent(clientId) + '/servicehook/new';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getServiceHook : function(clientId, serviceHookId, success, error, context) {
		var requestURL = '../runtime/client/' + encodeURIComponent(clientId) + '/servicehook/' + encodeURIComponent(serviceHookId);

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	
	addServiceHook : function(clientId, serviceHook, success, error, context) {		
		var requestURL = '../runtime/client/' + encodeURIComponent(clientId) + '/servicehook';
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(serviceHook),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	updateServiceHook : function(clientId, serviceHook, success, error, context) {		
		var requestURL = '../runtime/client/' + encodeURIComponent(clientId) + '/servicehook/' + encodeURIComponent(serviceHook.id);
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(serviceHook),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	changeServiceHookState : function(clientId, serviceHookId, state, success, error, context) {
		var requestURL = '../runtime/client/' + encodeURIComponent(clientId) + '/servicehook/' + encodeURIComponent(serviceHookId) + "/active/" + state;
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	removeServiceHook : function(clientId, serviceHook, success, error, context) {		
		var requestURL = '../runtime/client/' + encodeURIComponent(clientId) + '/servicehook/' + encodeURIComponent(serviceHook.id);
		
		$.ajax({
			url : requestURL,
			method: 'DELETE',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	resolveServiceHookReferences : function(clientId, serviceHook, success, error, context) {
		var requestURL = '../runtime/client/' + encodeURIComponent(clientId) + '/servicehook/' + encodeURIComponent(serviceHook.id) + '/references';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	validateServiceHook : function(clientId, serviceHook, success, error, context) {
		var requestURL = '../runtime/client/' + encodeURIComponent(clientId) + '/servicehook/warnings';
		
		$.ajax({
			url : requestURL,
			method: 'POST',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(serviceHook),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getServiceInterceptions : function(success, error, context) {
		var requestURL = '../runtime/client/servicehook/interception';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},

	getConServices : function(success, error, context) {
		var requestURL = '../runtime/client/servicehook/service';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getConMethods : function(serviceName, success, error, context) {
		var requestURL = '../runtime/client/servicehook/service/'+serviceName+'/method';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	
	getConErrors : function(serviceName, methodName, success, error, context) {
		var requestURL = '../runtime/client/servicehook/service/'+serviceName+'/method/'+methodName+'/error';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
};