function PuppetryLiveClientUI() {
	// Call the parent constructor
	AbstractDataListUI.call(this);
	
	var self = this;
	
	this._header = 'Aufrufkontext';
	this._contentId = '.live-client-content';
	this._listViewId = '.live-client-list';
	this._detailViewId = '.live-client-detail';
	this._entryId = '.live-client';
	this._entryTemplateId = '#live-client-template';
	this._sortBy = 'label';
	this._menuItemId = '.live-client';
	this._showDetailOnSelect = false;
	
	this._listEntryHandler = PuppetryLiveClientService.getClients;
	this._getEntryHandler = PuppetryLiveClientService.getClient;
	
	this._addEntryHandler = function(client, success, error, context) {
		var clientId = $(self._detailViewId).attr('client-id');
	};

	this._updateEntryHandler = function(client, success, error, context) {
		var clientId = $(self._detailViewId).attr('client-id');
	};
	
	this._removeEntryHandler = function(client, success, error, context) {
		var clientId = $(self._detailViewId).attr('client-id');
	};
	
	this.conServices = new Array();
};

// Create the prototype
PuppetryLiveClientUI.prototype = Object.create(AbstractDataListUI.prototype);

//Set the "constructor" property 
PuppetryLiveClientUI.prototype.constructor = PuppetryLiveClientUI;

PuppetryLiveClientUI.prototype.initUI = function() {
	AbstractDataListUI.prototype.initUI.call(this);
};

PuppetryLiveClientUI.prototype.showUI = function(source, detail) {
	AbstractDataListUI.prototype.showUI.call(this, source, detail);
	
	$('.live-mode > .header').text(this._header);
	
	if ($('#wrapper').hasClass('admin-mode')) {
		$('#wrapper').removeClass('admin-mode').addClass('live-mode');
		$('.admin-mode').hide();
	}
	$('.live-content').hide();
	$(this._contentId).show();
};

PuppetryLiveClientUI.prototype.showDetailUI = function(source, e) {
	AbstractDataListUI.prototype.showDetailUI.call(this, source, e);
	
	if (e) {
		e.stopPropagation();	
	}	
	
	$(this._listViewId).find(this._entryId).removeClass('active');
	$(source).closest(this._entryId).addClass('active');
	
	$(this._listViewId).find(this._entryId).find('.active-row').css('display', 'none');
	$(source).closest(this._entryId).find('.active-row').css('display', 'block');
}

PuppetryLiveClientUI.prototype.hideDetailUI = function() {
	AbstractDataListUI.prototype.hideDetailUI.call(this);
	$(this._listViewId).find(this._entryId).find('.active-row').css('display', 'none');
};

PuppetryLiveClientUI.prototype.toListView = function(model, viewElement) {
	AbstractDataListUI.prototype.toListView.call(this, model, viewElement);
	
	viewElement.attr('id', model.id); 
	viewElement.attr('label', model.label);
	viewElement.find('.client-name').text(model.label);
	
	var description = model.principalId + ' / ' + model.clientSystemId + ' / ' + model.workplaceId
	viewElement.find('.client-description').text(description);
	viewElement.attr('description', description);	
	
	if(model.active === true) {
		viewElement.find('.object-icon').removeClass('disabled');
		viewElement.find('.client-active').hide();
		viewElement.find('.client-inactive').show();
	} else {
		viewElement.find('.object-icon').addClass('disabled');
		viewElement.find('.client-active').show();
		viewElement.find('.client-inactive').hide();
	}
	
	var terminalCount;
	if (model.terminal) {
		if (typeof(model.terminal) == 'object') {
			terminalCount = model.terminal.length;
		} else {
			terminalCount = model.terminal;
		}
	} else {
		terminalCount = 0;
	}
	viewElement.find('.client-terminal-count').text(terminalCount);
	
	var serviceHookCount = 0;
	if (model.serviceHook) {
		if (typeof(model.serviceHook) == 'object') {
			serviceHookCount += model.serviceHook.length;
		} else {
			serviceHookCount += model.serviceHook;
		}
	}
	viewElement.find('.client-servicehook-count').text(serviceHookCount);
	
};

PuppetryLiveClientUI.prototype.toDetailView = function(model, detailView) {
	AbstractDataListUI.prototype.toDetailView.call(this, model, detailView);
	
	if (model.id != null && model.id != '') {
		detailView.attr('client-id', model.id);				
	} else {
		detailView.removeAttr('client-id');
	}
	
	if (model.label != null && model.label != '') {
		detailView.attr('label', model.label);
	} else {
		detailView.removeAttr('label');
	}
};

PuppetryLiveClientUI.prototype.toModel = function(viewElement, model) {
	var validationResult = AbstractDataListUI.prototype.toModel.call(this, viewElement, model);

	model.id = viewElement.attr('client-id');
	model.label = viewElement.attr('label');
	
	return validationResult;
};

PuppetryLiveClientUI.prototype.onDeleteDetailUISuccess = function(data, textStatus, jqXHR ) {
	var viewElement = $(this._entryId + '[id="' + data.id + '"]');
	this.toListView(data, viewElement);
	this.sortEntries();
	this.hideDetailUI();
};

PuppetryLiveClientUI.prototype.activate = function(source) {
	var self = this;

	var clientElmt = $(source).closest('.live-client');
	var clientId = clientElmt.attr('id');
	
	PuppetryLiveClientService.changeClientState(
			clientId,
			true,
			function(data, textStatus, jqXHR) {
				clientElmt.find('.client-active').hide();
				clientElmt.find('.client-inactive').show();
				clientElmt.find('.object-icon').removeClass('disabled');
			},
			EHexServiceUtil.onErrorHandler
		);
};

PuppetryLiveClientUI.prototype.deactivate = function(source) {
	var self = this;

	var clientElmt = $(source).closest('.live-client');
	var clientId = clientElmt.attr('id');
	
	PuppetryLiveClientService.changeClientState(
			clientId,
			false,
			function(data, textStatus, jqXHR) {
				clientElmt.find('.client-active').show();
				clientElmt.find('.client-inactive').hide();
				clientElmt.find('.object-icon').addClass('disabled');
			},
			EHexServiceUtil.onErrorHandler
		);
};
