
function PuppetryLiveEventUI() {
	this._header = '<span class="font-20">Konnektor &lt; </span><span class="font-50">Ereignisse</span>';
	this._contentId = '.live-event-content';
	this._menuItemId = '.live-event';
	
	this._events = new Array();
};

PuppetryLiveEventUI.prototype.initUI =  function() {
	var self = this;
	
	PuppetryConnectorService.getEvents(
			function(data, textStatus, jqXHR) {
				self.initSelectData(data, self._events);
			}, 
			EHexServiceUtil.onErrorHandler
		);
	
	$(this._contentId).find('.event').change(function() {
		self.changeSelectedEvent(this);
	});
};

PuppetryLiveEventUI.prototype.showUI = function() {
	$('.live-mode > .header').html(this._header);
	
	if ($('#wrapper').hasClass('admin-mode')) {
		$('#wrapper').removeClass('admin-mode').addClass('live-mode');
		$('.admin-mode').hide();
	}
	$('.live-content').hide();
	$(this._contentId).show();
	
	var detailHeight = $(window).height() - $('.navbar.navbar-default').height();
	$(this._contentId).css('min-height', detailHeight);			
	$(this._contentId).show();	
	
	this.initSelectBox(this._events, $(this._contentId).find('.event'), '');
	this.changeSelectedEvent();
};

PuppetryLiveEventUI.prototype.changeSelectedEvent = function(source) {
	var self = this;
	
	if (!source) {
		source = $(self._contentId).find('.event');
	}
	
	var value = $(source).val();
	$(this._contentId).find('.event-param').remove();
	$(this._contentId).find('.event-action').prop('disabled', value != null && value != '' ? false : true);
	if (value != null && value != '') {
		PuppetryConnectorService.getEventParameters(
				value, 
				function(data, textStatus, jqXHR ) {
					$.each(data, function(key, value) {
						var eventParam = $('#event-param-template').clone(true);
						eventParam.removeAttr('id');
						eventParam.find('.event-param-name').text(key);
						eventParam.find('.event-param-value').val(value);
						eventParam.css('display', 'block');
						$(self._contentId).find('.event-params').append(eventParam);
					});
				}, 
				EHexServiceUtil.onErrorHandler
			);
	} 
};

PuppetryLiveEventUI.prototype.sendEvent = function() {
	var eventId = $(this._contentId).find('.event').val();
	if (eventId != null && eventId != '') {
		var parameters = {};
		$(this._contentId).find('.event-param').each(function(index, element) {
			var name = $(element).find('.event-param-name').text();			
			var value = $(element).find('.event-param-value').val();
			parameters[name] = value;
		});
		PuppetryConnectorService.sendEvent(
				eventId, 
				parameters, 
				function(data, textStatus, jqXHR ) {
					if(data === false) {
						EHexAlertUI.showInfo('Das Ereignis wurde unterdrückt, da der Konnektor ausgeschaltet ist.');
					}
					else {
						EHexAlertUI.showInfo('Das Ereignis wurde erfolgreich ausgelöst.');
					}
				}, 
				EHexServiceUtil.onErrorHandler
			);
	}
};

PuppetryLiveEventUI.prototype.initSelectData = function(source, target) {
	target.push({value: '', label: ''});
	$.each(source, function(value, label) {
		var entry = {value: value, label: label};
		target.push(entry);
	});
	
	target.sort(function(a, b) {
		var labelA = $(a).attr('label');
		var labelB = $(b).attr('label');
		if (labelA > labelB) {
			return 1;
		} else if (labelA < labelB) {
			return -1;
		} else {
			return 0;
		}
	});
};
		
PuppetryLiveEventUI.prototype.initSelectBox = function(source, target, value) {
	target.empty();
	$.each(source, function(key, entry) {
		var selected = (entry.value === value ? ' selected="selected" ' : ''); 
		target.append('<option ' + selected + ' value=' + entry.value + '>' + entry.label + '</option>');
	});
};