function PuppetryLiveSubscriptionUI() {
	// Call the parent constructor
	AbstractDataListUI.call(this);
	
	this._header = '<span class="font-20">Konnektor &lt; </span><span class="font-50">Ereignis-Abonnenten</span>';
	this._contentId = '.live-subscription-content';
	this._entryId = '.live-subscription';
	this._entryTemplateId = '#live-subscription-template > table > tbody > tr';
	this._sortBy = 'sorting';
	this._menuItemId = '.live-subscription';
	this._listViewId = '.live-subscription-list';
	
	this._listEntryHandler = PuppetryConnectorService.getSubscriptions;
	this._removeEntryHandler = PuppetryConnectorService.removeSubscription;
}

//Create the prototype
PuppetryLiveSubscriptionUI.prototype = Object.create(AbstractDataListUI.prototype);

//Set the "constructor" property 
PuppetryLiveSubscriptionUI.prototype.constructor = PuppetryLiveSubscriptionUI;
		
PuppetryLiveSubscriptionUI.prototype.initUI = function() {
	AbstractDataListUI.prototype.initUI.call(this);
};

PuppetryLiveSubscriptionUI.prototype.showUI = function(source, detail) {
	AbstractDataListUI.prototype.showUI.call(this, source, detail);
	
	var self = this;
	
	$('.live-mode > .header').html(this._header);
	
	if ($('#wrapper').hasClass('admin-mode')) {
		$('#wrapper').removeClass('admin-mode').addClass('live-mode');
		$('.admin-mode').hide();
	}
	$('.live-content').hide();
	$(this._contentId).show();
};

PuppetryLiveSubscriptionUI.prototype.toListView = function(model, viewElement) {
	AbstractDataListUI.prototype.toListView.call(this, model, viewElement);
	viewElement.css('display', 'table-row');
	
	viewElement.attr('id', model.info.subscriptionId);
	viewElement.attr('sorting', model.endpoint + '#' + model.topicFilter);
	viewElement.attr('description', JSON.stringify(model));
	
	viewElement.find('.endpoint').text(model.endpoint);
	viewElement.find('.subscriptionId').text(model.info != null  ? model.info.subscriptionId : '');	
	viewElement.find('.terminationTime').text(model.info != null && model.info.terminationTime != null ? this.getFormattedDate(new Date(model.info.terminationTime)) : '');
	viewElement.find('.principalId').text(model.contextFilter != null ? model.contextFilter.principalId : '');
	viewElement.find('.clientSystemId').text(model.contextFilter != null ? model.contextFilter.clientSystemId : '');
	viewElement.find('.workplaceId').text(model.contextFilter != null ? model.contextFilter.workplaceId : '');
	viewElement.find('.topicFilter').text(model.topicFilter != null ? model.topicFilter : '');
	viewElement.find('.xPathFilter').text(model.xPathFilter != null ? model.xPathFilter : '');
};

PuppetryLiveSubscriptionUI.prototype.getFormattedDate = function(date) {
    var month = date.getMonth() + 1;
    var day = date.getDate();
    var hour = date.getHours();
    var min = date.getMinutes();
    var sec = date.getSeconds();

    month = (month < 10 ? "0" : "") + month;
    day = (day < 10 ? "0" : "") + day;
    hour = (hour < 10 ? "0" : "") + hour;
    min = (min < 10 ? "0" : "") + min;
    sec = (sec < 10 ? "0" : "") + sec;

    var str = day + "." + month + "." + date.getFullYear() + " " +  hour + ":" + min + ":" + sec;

    return str;
};

PuppetryLiveSubscriptionUI.prototype.onDeleteDetailUISuccess = function(data, textStatus, jqXHR ) {
	var self = this;
	this._listEntryHandler(
			function(data, textStatus, jqXHR) {
				self.onEntriesSuccess(data, textStatus, jqXHR);	
			}, 
			EHexServiceUtil.onErrorHandler, 
			this
		);
};