function PuppetryLiveTestCaseSetUI() {
	// Call the parent constructor
	AbstractDataListUI.call(this);
	
	
	this._header = 'Testlabor';
	this._contentId = '.live-testcase-set-content';
	this._listViewId = '.live-testcase-set-list';
	this._detailViewId = '.live-testcase-set-detail';
	this._entryId = '.live-testcase-set';
	this._entryTemplateId = '#live-testcase-set-template';
	this._sortBy = 'label';
	this._menuItemId = '.live-testcase-set';
	
	this._updateEntryHandler = this.saveGematikTestCaseProfileData;
	
	this._listEntryHandler = PuppetryTestCaseService.getTestCaseSets;
	this._getEntryHandler = PuppetryTestCaseService.getTestCaseSet;
	
};

// Create the prototype
PuppetryLiveTestCaseSetUI.prototype = Object.create(AbstractDataListUI.prototype);

//Set the "constructor" property 
PuppetryLiveTestCaseSetUI.prototype.constructor = PuppetryLiveTestCaseSetUI;

PuppetryLiveTestCaseSetUI.prototype.initUI = function() {
	AbstractDataListUI.prototype.initUI.call(this);

	var self = this;
	
	$(self._contentId).find('.testcase-set-detail-testreport input').change(
		function () { 
			$(self._contentId).find('.testcase-set-detail-testreport button').prop('disabled', 'disabled');
			$(self._contentId).find('.testcase-set-detail-testreport button').attr('title', 'Um den Testbericht zu erzeugen, müssen erst alle ungespeicherten Änderungen übernommen werden.')
		}
	);
};

PuppetryLiveTestCaseSetUI.prototype.showUI = function(source, detail) {
	AbstractDataListUI.prototype.showUI.call(this, source, detail);
	
	$('.live-mode > .header').text(this._header);
	
	if ($('#wrapper').hasClass('admin-mode')) {
		$('#wrapper').removeClass('admin-mode').addClass('live-mode');
		$('.admin-mode').hide();
	}
	$('.live-content').hide();
	$(this._contentId).show();
};

PuppetryLiveTestCaseSetUI.prototype.onEntrySuccess = function(data, textStatus, jqXHR) {
	var self = this;
	var detailView =  $(this._detailViewId);
		
	PuppetryProfileService.getProfile(
			function(profileData, textStatus, jqXHR ) {
				self.showGematikTestCaseProfileData(detailView, profileData);
			}, 
			EHexServiceUtil.onErrorHandler
	);
	
	AbstractDataListUI.prototype.onEntrySuccess.call(this, data, textStatus, jqXHR);
};

PuppetryLiveTestCaseSetUI.prototype.toListView = function(model, viewElement) {
	AbstractDataListUI.prototype.toListView.call(this, model, viewElement);
	
	viewElement.attr('id', model.id); 
	viewElement.attr('label', model.label);
	viewElement.attr('protected', model.protected);
	if(!model.result) {
		viewElement.addClass("disabled");
	}

	if(model.protected) {
		viewElement.find('.badge-state.testcase-set-protected').removeClass('off');
	}
	
	viewElement.find('.testcase-set-name').text(model.label);
};

PuppetryLiveTestCaseSetUI.prototype.toDetailView = function(model, detailView) {
	AbstractDataListUI.prototype.toDetailView.call(this, model, detailView);

	var self = this;
	
	if (model.id != null && model.id != '') {
		detailView.attr('testcase-set-id', model.id);				
	} else {
		detailView.removeAttr('testcase-set-id');
	}
	
	if (model.label != null && model.label != '') {
		detailView.attr('label', model.label);
	} else {
		detailView.removeAttr('label');
	}

	detailView.find('.testcase-set-size').text((model.summary.successful + model.summary.error + model.summary.untested + model.summary.unsupported));
	detailView.find('.testcase-set-tested').text((model.summary.successful + model.summary.error));
	detailView.find('.testcase-set-successful').text(model.summary.successful);
	detailView.find('.testcase-set-error').text(model.summary.error);
	detailView.find('.testcase-set-untested').text(model.summary.untested);
	detailView.find('.testcase-set-unsupported').text(model.summary.unsupported);
	
	if(model.protected) {
		detailView.find('.testcase-set-detail-testreport-toggle').show();
		detailView.find('.apply-button').show();

	}
	else {
		detailView.find('.apply-button').hide();
		detailView.find('.testcase-set-detail-testreport-toggle').hide();
		if(detailView.find('.testcase-set-detail-testreport-toggle').hasClass("active")) {
			detailView.find('.testcase-set-detail-testreport-toggle').removeClass('active');
			detailView.find('.testcase-set-detail-overview-toggle').addClass('active');
			self.showOverviewUI();
		}
	}
};

PuppetryLiveTestCaseSetUI.prototype.showLiveTestCaseUI = function(source) {
	var testSet = $(source).closest('.live-testcase-set');
	var setId = testSet.attr('id');
	var isProtected = testSet.attr('protected');
	
	if(isProtected == 'true') {
		var profile =  this.getProfileObject();
	    if ((!profile.psName) || profile.psName.length === 0 || //
	        (!profile.psVersion) || profile.psVersion.length === 0 ){
	    	var msg = "Die Angaben zum bzgl. Primärsystem Name/Version sind nicht vollständig. Wenn sie nun einen Testfall ausführen, fehlen diese Angaben in dem Testfallergebnis PDF.\n\nWollen sie dennoch zu den Testfällen wechseln?";
			EHexDialogUI.confirm(msg, function () { Puppetry.showLiveTestCaseUI(source); });
		}
	    else {
	    	Puppetry.showLiveTestCaseUI(source); 
	    }
	}
	else {
		Puppetry.showLiveTestCaseUI(source); 
	}
	
};

PuppetryLiveTestCaseSetUI.prototype.showGematikTestCaseProfileData = function(detailView, model) {
	detailView.find('.testcase-gematik-psName').val(model.psName);
	detailView.find('.testcase-gematik-psVersion').val(model.psVersion);
	detailView.find('.testcase-gematik-referenceNumberLEO').val(model.referenceNumberLEO);
	detailView.find('.testcase-gematik-referenceNumberZLS').val(model.referenceNumberZLS);
	detailView.find('.testcase-gematik-testerName').val(model.testerName);
	
	$(this._contentId).find('.testcase-set-detail-testreport button').removeAttr("disabled");
	$(this._contentId).find('.testcase-set-detail-testreport button').removeAttr("title");
};

PuppetryLiveTestCaseSetUI.prototype.saveGematikTestCaseProfileData = function(model, onApplyDetailUISuccess, onErrorHandler, self) {
	
	if($(this._contentId).find('.testcase-set-detail-testreport-toggle').is(":visible")) {
		var profile = this.getProfileObject();

		PuppetryProfileService.updateProfile(
				profile,
				onApplyDetailUISuccess, 
				onErrorHandler,
				self
		);
	}
};

PuppetryLiveTestCaseSetUI.prototype.onApplyDetailUISuccess = function(data, textStatus, jqXHR) {
	data.hasWarnings = false;
	this.filterEntries();
	this.sortEntries();
	this.hideDetailUI();
};


PuppetryLiveTestCaseSetUI.prototype.getProfileObject = function(callback) {
	var profile = {};
	profile.psName = $(this._contentId).find('.testcase-gematik-psName').val();
	profile.psVersion = $(this._contentId).find('.testcase-gematik-psVersion').val();
	profile.referenceNumberLEO = $(this._contentId).find('.testcase-gematik-referenceNumberLEO').val();
	profile.referenceNumberZLS = $(this._contentId).find('.testcase-gematik-referenceNumberZLS').val();
	profile.testerName = $(this._contentId).find('.testcase-gematik-testerName').val();
	
	return profile;
}

PuppetryLiveTestCaseSetUI.prototype.toModel = function(viewElement, model) {
	var validationResult = AbstractDataListUI.prototype.toModel.call(this, viewElement, model);
	
	model.id = viewElement.attr('testcase-set-id');
	
	return validationResult;
};

PuppetryLiveTestCaseSetUI.prototype.showOverviewUI = function(source) {
	$('.testcase-set-detail-overview').css('display', 'block');
	$('.testcase-set-detail-testreport').css('display', 'none');	
	$('.testcase-set-detail-reset').css('display', 'none');	
};

PuppetryLiveTestCaseSetUI.prototype.showTestReportUI = function(source) {
	$('.testcase-set-detail-overview').css('display', 'none');
	$('.testcase-set-detail-testreport').css('display', 'block');	
	$('.testcase-set-detail-reset').css('display', 'none');	
};

PuppetryLiveTestCaseSetUI.prototype.showResetUI = function(source) {
	$('.testcase-set-detail-overview').css('display', 'none');
	$('.testcase-set-detail-testreport').css('display', 'none');	
	$('.testcase-set-detail-reset').css('display', 'block');
};

PuppetryLiveTestCaseSetUI.prototype.resetTestCases = function(source) {
	var self = this;
	
	var testSeteId;
	
	if (source) {
		var testCaseElmt = $(source).closest('.live-testcase-set');
		testSeteId = testCaseElmt.attr('id');
	} else {
		testSeteId = $(this._detailViewId).attr('testcase-set-id');
	}

	if (testSeteId) {
		EHexDialogUI.showWait('Daten werden zurückgesetzt...');
		
		PuppetryTestCaseService.resetTestcases(
				testSeteId, 
				function(data, textStatus, jqXHR) {
					var detailView =  $(self._detailViewId);
					self.toDetailView(data, detailView);
					var listViewElement = $('.live-testcase-set#' + testSeteId);
					listViewElement.addClass("disabled");
					
					setTimeout(EHexDialogUI.hideWait, 250);
				}, 
				EHexServiceUtil.onErrorHandler,
				this
		);	
	}
};

PuppetryLiveTestCaseSetUI.prototype.getReportFile = function(source) {
	var self = this;

	var testCaseId;
	var testCaseName;
	
	if (source) {
		var testCaseElmt = $(source).closest('.live-testcase');
		testCaseId = testCaseElmt.attr('id');
		testCaseName = testCaseElmt.attr('label');
	} else {
		testCaseId = $(this._detailViewId).attr('testcase-id');
		testCaseName = $(this._detailViewId).attr('label');
	}

	if (testCaseId) {
		PuppetryTestCaseService.getTestCaseReport(
				testCaseId, 
				function(data, textStatus, jqXHR) {}, 
				EHexServiceUtil.onErrorHandler,
				this
		);	
	}
};

PuppetryLiveTestCaseSetUI.prototype.validateGematikReportPrecondition = function() {
	var detailView  = $(this._detailViewId);
	
	if(parseInt(detailView.find('.testcase-set-untested').text()) > 0) {
		
		EHexAlertUI.showError('Der Testbericht kann nur erzeugt werden, wenn alle Testfälle durchgeführt wurden.');
		return false;
	}
    else {
    	var profile = this.getProfileObject();
    	
    	if ((!profile.psName) || profile.psName.length === 0 || //
    			(!profile.psVersion) || profile.psVersion.length === 0 || //
    			(!profile.testerName) || profile.testerName.length === 0) {
    		
    		EHexAlertUI.showError('Die Angaben für die Erstellung des Testberichts sind nicht vollständig.');
    		
    		return false;
    	}
    	else {
    		return true;
    	}
    }
    
};

PuppetryLiveTestCaseSetUI.prototype.getGematikZIP = function(source) {
	var setId;
	
	if(source) {
		var testSet = $(source).closest('.live-testcase-set');
		setId = testSet.attr('id');
	}
	else {
		setId = $(this._detailViewId).attr('testcase-set-id');
	}
	
	var self = this;
	
	if(self.validateGematikReportPrecondition()) {
		PuppetryTestCaseService.getPSList(
				setId,
				function (psList) {
					if(psList.length > 1) {
						var msg = "Es sind unterschiedliche Angaben zum Primärsystem Name/Version (" + psList.toString() + ") in den Testfallergebnis PDFs vorhanden. \n\nSoll dennoch ein Testbericht erzeugt werden?";
						EHexDialogUI.confirm(msg, function () { PuppetryTestCaseService.downloadTestCasesReportZIP(setId); });
					}
					else {
						PuppetryTestCaseService.downloadTestCasesReportZIP(setId);
					}
				},
				EHexServiceUtil.onErrorHandler,
				self
		);
	}
};

PuppetryLiveTestCaseSetUI.prototype.getGematikPDF = function(source) {
	var setId;
	
	if(source) {
		var testSet = $(source).closest('.live-testcase-set');
		setId = testSet.attr('id');
	}
	else {
		setId = $(this._detailViewId).attr('testcase-set-id');
	}
	
	var self = this;
	
	if(self.validateGematikReportPrecondition()) {
		PuppetryTestCaseService.getPSList(
				setId,
				function (psList) {
					if(psList.length > 1) {
						var msg = "Es sind unterschiedliche Angaben zum Primärsystem Name/Version (" + psList.toString() + ") in den Testfallergebnis PDFs vorhanden. \n\nSoll dennoch ein Testbericht erzeugt werden?";
						EHexDialogUI.confirm(msg, function () { PuppetryTestCaseService.downloadTestCasesReportPDF(setId); });
					}
					else {
						PuppetryTestCaseService.downloadTestCasesReportPDF(setId);
					}
				},
				EHexServiceUtil.onErrorHandler,
				self
		);
	}
};

PuppetryLiveTestCaseSetUI.prototype.getPDF = function(source) {
	var setId;
	
	if(source) {
		var testSet = $(source).closest('.live-testcase-set');
		setId = testSet.attr('id');
	}
	else {
		setId = $(this._detailViewId).attr('testcase-set-id');
	}
	
	PuppetryTestCaseService.downloadTestCasesSummaryPDF(setId);	
};

PuppetryLiveTestCaseSetUI.prototype.getXLS = function(source) {
	var setId;
	
	if(source) {
		var testSet = $(source).closest('.live-testcase-set');
		setId = testSet.attr('id');
	}
	else {
		setId = $(this._detailViewId).attr('testcase-set-id');
	}

	PuppetryTestCaseService.downloadTestCasesSummaryXLS(setId);	
};

PuppetryLiveTestCaseSetUI.prototype.getZIP = function(source) {
	var setId;
	
	if(source) {
		var testSet = $(source).closest('.live-testcase-set');
		setId = testSet.attr('id');
	}
	else {
		setId = $(this._detailViewId).attr('testcase-set-id');
	}

	PuppetryTestCaseService.downloadTestCasesZIP(setId);	
};
