var PuppetrySMCBService = {
		
	getSMCBs : function(success, error, context) {
		var requestURL = "../healthcard";

		$.ajax({
			url : requestURL,
			dataType : "json",
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getSMCB : function(cardId, success, error, context) {
		var requestURL = '../healthcard/' + cardId;

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getSMCBReferences : function(smcb, success, error, context) {
		var requestURL = '../healthcard/' + smcb.id + '/references';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	newSMCB : function(success, error, context) {
		var requestURL = '../healthcard/new';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	addSMCB : function(smcb, success, error, context) {		
		var requestURL = '../healthcard';
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(smcb),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	updateSMCB : function(smcb, success, error, context) {		
		var requestURL = '../healthcard/' + encodeURIComponent(smcb.id);
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(smcb),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	cloneSMCB : function(smcb, success, error, context) {
		var requestURL = '../healthcard/' + encodeURIComponent(smcb.id) + '/clone';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	renameSMCB : function(id, newLabel, success, error, context) {		
		var requestURL = '../healthcard/' + encodeURIComponent(id) +'/label/' + encodeURIComponent(newLabel);
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	removeSMCB : function(smcb, success, error, context, force) {		
		var requestURL = '../healthcard/' + encodeURIComponent(smcb.id);
		if (force === true) {
			requestURL += '?force=true';
		}
		
		$.ajax({
			url : requestURL,
			method: 'DELETE',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	validateSMCB : function(smcb, success, error, context) {
		var requestURL = '../healthcard/warnings';
		
		$.ajax({
			url : requestURL,
			method: 'POST',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(smcb),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getPinStatus : function(success, error, context) {
		var requestURL = '../healthcard/pinstatus';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
};