(function(XHR) {
    "use strict";
    
    var open = XHR.prototype.open;
    var send = XHR.prototype.send;
    
    XHR.prototype.open = function(method, url, async, user, pass) {
        this._url = url;
        open.call(this, method, url, async, user, pass);
    };
    
    XHR.prototype.send = function(data) {
        var self = this;
        var oldOnReadyStateChange;
        var url = this._url;       
        
        function onReadyStateChange() {
        	/*
        	 * 0: request not initialized 
			 * 1: server connection established
			 * 2: request received 
			 * 3: processing request 
			 * 4: request finished and response is ready
        	 */
            if(self.readyState == 4 /* complete */) {
            	PuppetryTestCaseService.getActiveTestCase(
                		function(data, textStatus, jqXHR) {
                			if (data) {
                				Puppetry.screenMode = 'live-mode';
                				Puppetry.status[Puppetry.screenMode] = 'live-testcase-ui';
                				Puppetry.controller['live-testcase-ui'].showWizard(data);
                			}
                		},
                		EHexServiceUtil.onErrorHandler,
                		self
                );
            }
            
            
            
            if(oldOnReadyStateChange) {
                oldOnReadyStateChange();
            }
        }
        
        if (url.startsWith('../testcaseset/testrun') || url.startsWith('../config')) {
        	this.noIntercept = true;
        }
        
        if(!this.noIntercept) {
            if(this.addEventListener) {
                this.addEventListener("readystatechange", onReadyStateChange, false);
            } else {
                oldOnReadyStateChange = this.onreadystatechange; 
                this.onreadystatechange = onReadyStateChange;
            }
        }
        
        send.call(this, data);
    }
})(XMLHttpRequest);