var PuppetryTestCaseService = {
		
	getTestCaseSets : function(success, error, context) {
		var requestURL = '../testcaseset';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},		

	getTestCaseSet : function(id, success, error, context) {
		var requestURL = '../testcaseset/' + id;

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},

	resetTestcases : function(id, success, error, context) {
		var requestURL = '../testcaseset/' + id + '/testcase/reports';
		
		$.ajax({
			url : requestURL,
			method: 'DELETE',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},

	resetTestcase : function(setId, id, success, error, context) {
		var requestURL = '../testcaseset/' + setId + '/testcase/' + id + '/report';
		
		$.ajax({
			url : requestURL,
			method: 'DELETE',
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getPSList : function(id, success, error, context) {
		var requestURL = '../testcaseset/' + id + '/testcase/pslist';
		
		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getTestCases : function(setid, success, error, context) {
		var requestURL = '../testcaseset/' + setid  + '/testcase';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getTestCase : function(setid, id, success, error, context) {
		var requestURL = '../testcaseset/' + setid  + '/testcase/' + id;

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
				
	setUnsupported : function(setid, id, flag, success, error, context) {
		var requestURL = '../testcaseset/' + setid  + '/testcase/' + encodeURIComponent(id) + '/unsupported/' + flag;
		
		$.ajax({
			url : requestURL,
			method: 'PUT',
			contentType: 'application/json',
			success : success,
			error : error,
			timeout : 150000,
			context : context			
		});
	},
	
	startTestCase : function(setid, id, success, error, context) {
		var requestURL = '../testcaseset/' + setid  + '/testcase/' + encodeURIComponent(id) + '/start';
		
		$.ajax({
			url : requestURL,
			method: 'POST',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify({}),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
		
	
	
	completeTestCase : function(success, error, context) {
		var requestURL = '../testcaseset/testrun/complete';
		
		$.ajax({
			url : requestURL,
			method: 'POST',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify({}),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	cancelTestCase : function(success, error, context) {
		var requestURL = '../testcaseset/testrun/cancel';
		
		$.ajax({
			url : requestURL,
			method: 'POST',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify({}),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	nextTestCaseStep : function(success, error, context) {
		var requestURL = '../testcaseset/testrun/next';
		
		$.ajax({
			url : requestURL,
			method: 'POST',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify({}),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	validateTestCaseStep : function(success, error, context) {
		var requestURL = '../testcaseset/testrun/validate';
		
		$.ajax({
			url : requestURL,
			method: 'POST',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify({}),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	commentTestCaseStep : function(validationResult, success, error, context) {
		var requestURL = '../testcaseset/testrun/comment';
		
		$.ajax({
			url : requestURL,
			method: 'POST',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify(validationResult),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
		
	executeTestCaseStep : function(success, error, context) {
		var requestURL = '../testcaseset/testrun/execute';
		
		$.ajax({
			url : requestURL,
			method: 'POST',
			contentType: 'application/json',
			dataType : 'json',
			data: JSON.stringify({}),	
			success : success,
			error : error,
			timeout : 150000,
			context : context
		});
	},
	
	getActiveTestCase : function(success, error, context) {
		var requestURL = '../testcaseset/testrun/active';

		$.ajax({
			url : requestURL,
			dataType : 'json',
			success : success,
			error : error,
			timeout : 150000,
			context : context,
			cache: false
		});
	},
	
	
	
	getTestCaseLog : function(setid, id, success, error, context) {
		window.open('../testcaseset/' + setid  + '/testcase/' + id + '-logs.zip', '_blank');
	},
	
	getTestCaseReport : function(setid, id, success, error, context) {
		window.open('../testcaseset/' + setid  + '/testcase/' + id + '/report', '_blank');
	},
	
	downloadTestCasesSummaryXLS : function(setid) {
		window.open('../testcaseset/' + setid  + '/testcase/summary/xls','_blank');
	},

	downloadTestCasesSummaryPDF : function(setid) {
		window.open('../testcaseset/' + setid  + '/testcase/summary/pdf','_blank');
	},

	downloadTestCasesZIP : function(setid) {
		window.open('../testcaseset/' + setid  + '/testcase/Testuebersicht.zip','_blank');
	},

	downloadTestCasesReportPDF : function(setid) {
		window.open('../testcaseset/' + setid  + '/testcase/report/pdf','_blank');
	},
	
	downloadTestCasesReportZIP : function(setid) {
		window.open('../testcaseset/' + setid  + '/testcase/Testbericht.zip','_blank');
	},

};