var PuppetryWizardUI = {
		
	wizardData : null,	
		
	isActive : function() {
		return $('#wizardDialog').is(':visible');
	},	
	
	currentStep : function() {
		return  $('#wizardDialog ul.tabs li').index($('#wizardDialog ul.tabs li.active'));
	},	
	
	startWizard : function(wizardData, index, onNext, onComplete, onCancel) {
		var wizardDialog = $('#wizardDialog');
		PuppetryWizardUI.wizardData = wizardData;
		
		wizardDialog.addClass(Puppetry.screenMode);
		wizardDialog.css('height', '90%');
		wizardDialog.css('width', '90%');		
				
		var wizard = wizardDialog.find('.wizard-content');
		
		var wizardHeader = wizard.find('.modal-header');		
		var wizardFooter = wizard.find('.modal-footer');
		var wizardBody = wizard.find('.modal-body');
		wizard.css('height', '100%');
		
		wizardHeader.find('.wizard-title').text(wizardData.name);
		wizardHeader.find('.wizard-title').attr('title', wizardData.shortDescription);
		wizardHeader.find('.tabs').empty();
		wizard.find('.modal-body').find('.tab-content').find('.tab-pane').remove();
		
		if (wizardData.steps) {
			for (var i = 0; i < wizardData.steps.length; i++) {
				var step = wizardData.steps[i];
				var tabNo = i + 1;				
				var tabText = 'Schritt ' + tabNo + (step.data && step.data.shortDescription ? ': ' + step.data.shortDescription : '');
				wizardHeader.find('.tabs').append('<li><a href="#tab' + tabNo + '" data-toggle="tab">' + tabText + '</a></li>');
				wizardBody.find('.tab-content').append('<div class="tab-pane pd-10-5" id="tab' + tabNo + '"></div>');
				wizardBody.find('.tab-content').find('.tab-pane:last').html(step.page);
			}
		}
		
		if (index >= wizardData.steps.length - 1) {					
			wizardFooter.find('.next').hide();
			wizardFooter.find('.cancel').hide();
			wizardFooter.find('.complete').show();
		} else {
			wizardFooter.find('.next').show();
			wizardFooter.find('.cancel').show();
			wizardFooter.find('.complete').hide();
		}
				
		if (wizard.data('bootstrapWizard')) {
			wizard.data('bootstrapWizard').resetWizard();
		};

		wizard.bootstrapWizard({
			//withVisible : false,
			onTabClick: function(tab, navigation, index) {
				return false;
			},
			
			onTabChange: function(tab, navigation, index, nextTab) {
				if (PuppetryWizardUI.disabled === true) {
					return false;
				}
				
				if (index >= 0 && index < PuppetryWizardUI.wizardData.steps.length) {
					var onTabChangeHandler = PuppetryWizardUI.wizardData.steps[index].onTabChange;
					if (onTabChangeHandler && typeof(onTabChangeHandler) == 'function') {
						onTabChangeHandler(tab, navigation, index, nextTab);
					}
				}
			},
			
			onNext: function(tab, navigation, index) {
				if (PuppetryWizardUI.disabled === true) {
					return false;
				}
				
				var onNextHandler = PuppetryWizardUI.wizardData.steps[index - 1].onNext;
				if (!onNextHandler || typeof(onNextHandler) != 'function') {
					onNextHandler = onNext;
				}
				if (onNextHandler && typeof(onNextHandler) == 'function') {
					onNextHandler(tab, navigation, index);
				} 
				
				if (index >= PuppetryWizardUI.wizardData.steps.length - 1) {					
					wizardFooter.find('.next').hide();
					wizardFooter.find('.cancel').hide();
					wizardFooter.find('.complete').show();
				}
				return false;
			}
		});
		
		if (index > 0 && index < wizardData.steps.length) {
			console.log("bootstrapWizard show");			
			wizard.data('bootstrapWizard').show(index);
		}
		
		wizardDialog.find('.cancel').off('click');
		wizardDialog.find('.cancel').on('click', function() {
			if (PuppetryWizardUI.disabled === true) {
				return false;
			}
			if (onCancel && typeof(onCancel) == 'function') {
				onCancel(true);
			} 
			wizardDialog.modal('hide');			
		});
		
		wizardDialog.find('.complete').off('click');
		wizardDialog.find('.complete').on('click', function() {
			if (PuppetryWizardUI.disabled === true) {
				return false;
			}
			if (onComplete && typeof(onComplete) == 'function') {
				onComplete(true);
			} 
			wizardDialog.modal('hide');			
		});
		
		wizardDialog.one('hidden.bs.modal', function() {
			wizardDialog.removeClass('admin-mode').removeClass('live-mode');
		});	
		wizardDialog.modal('show');
		wizardBody.css('height', wizardDialog.outerHeight() - wizardHeader.outerHeight() - wizardFooter.outerHeight());
	},
	
	hideWizard : function() {
		var wizardDialog = $('#wizardDialog');
		wizardDialog.modal('hide');	
	},
	
	showWait : function(message) {
		PuppetryWizardUI.disabled = true;
		var wizardDialog = $('#wizardDialog');
		wizardDialog.find('.tab-content').hide();
		wizardDialog.find('.wait-content').find('.wait-content-message').html(message);
		wizardDialog.find('.wait-content').show();
	},
	
	hideWait : function() {
		var wizardDialog = $('#wizardDialog');		
		wizardDialog.find('.wait-content').hide();
		wizardDialog.find('.wait-content').find('.wait-content-message').html('Bitte warten...');
		wizardDialog.find('.tab-content').show();
		PuppetryWizardUI.disabled = false;
	},
	
	showNext : function(index) {
		var wizardDialog = $('#wizardDialog');
		wizardDialog.find('.validate-content').hide();
		var wizard = wizardDialog.find('.wizard-content');
		if (wizard.data('bootstrapWizard')) {
			wizard.data('bootstrapWizard').show(index);
		};
	},
	
	showValidation : function() {
		var wizardDialog = $('#wizardDialog');		
		wizardDialog.find('.wait-content').hide();
		wizardDialog.find('.tab-content').hide();
		wizardDialog.find('.validate-content').show();
	},
	
};
