var Puppetry = {		
		
		screenMode : 'live-mode',
		
		controller : {
			'live-client-ui' : new PuppetryLiveClientUI(),
			'live-client-servicehook-ui' : new PuppetryLiveClientServiceHookUI(),
			'live-client-terminal-ui' : new PuppetryLiveClientTerminalUI(),
			'live-protocol-ui' : new PuppetryLiveProtocolUI(),
			'live-subscription-ui' : new PuppetryLiveSubscriptionUI(),
			'live-event-ui' : new PuppetryLiveEventUI(),
			'live-testcase-set-ui' : new PuppetryLiveTestCaseSetUI(),
			'live-testcase-ui' : new PuppetryLiveTestCaseUI(),
			'admin-client-ui' : new PuppetryClientUI(),
			'admin-client-terminal-ui' : new PuppetryClientTerminalUI(),
			'admin-ehc-ui' : new PuppetryEhcUI(),
			'admin-smcb-ui' : new PuppetrySmcbUI(),
			'admin-backup-ui' : new PuppetryBackupUI(),			
			'common-connector-status-ui' : new PuppetryConnectorStatusUI(),
			'common-connector-clientsystem-authentication-ui' : new PuppetryClientSystemUI(),
			'common-connector-log-ui' : new PuppetryConnectorLogUI(),			
			'common-connector-settings-ui' : new PuppetryConnectorSettingsUI(),
			'common-systeminfo' : new PuppetrySystemInfoUI()
		},
		
		status : {
			'live-mode' : 'live-client-ui',
			'admin-mode' : 'admin-client-ui'
		},
		
		adjustContent : function() {
			
			var liveLogPanel = $('.jsPanel.jsPanel-theme-puppetry');
			if(liveLogPanel.length ) {
				if(liveLogPanel.attr("prev-width") != liveLogPanel.width() ||
				   liveLogPanel.attr("prev-height") != liveLogPanel.height()) {
					
					liveLogPanel.attr("prev-width", liveLogPanel.width())
					liveLogPanel.attr("prev-height", liveLogPanel.height())
				}
				else {
					if(((liveLogPanel.position().top + liveLogPanel.height()-50) > $(window).height()) ||
							((liveLogPanel.position().left + liveLogPanel.width()-50) > $(window).width())) {
						Puppetry.showLiveProtocolUI();					
					}
				}
			}
			
			if (this.currentController() && typeof(this.currentController().adjustContent) == 'function') {				
				this.currentController().adjustContent();		
			} else {
				var windowHeight = $(window).height();
				var navbarHeight = $('.navbar-fixed-top').outerHeight(true);
				var maxHeight = windowHeight > navbarHeight ? windowHeight : navbarHeight;
				
				var detailHeight = maxHeight - $('.navbar.navbar-default').outerHeight(true) - ($('.list-filter').is(":visible") ? $('.list-filter').outerHeight(true): 0);
				$('.detail').css('min-height', detailHeight);
				$('.detail-content').css('min-height', detailHeight - 100);
				
				$('.scrollable-data-list').css('min-height', detailHeight);
				$('.scrollable-data-list').css('height', detailHeight);
			}
		},
		
		confirmDirty : function(callback) {
			if (this.currentController() && typeof(this.currentController().confirmDirty) == 'function') {				
				this.currentController().confirmDirty(callback);		
			} else {
				callback(true);
			}
		},
		
		showUI : function(controllerId, source, detail) {
			var self = this;
			this.confirmDirty(function(result) {
				if (result) {
					if (!controllerId) {
						controllerId = Puppetry.status[Puppetry.screenMode];
						EHexDialogUI.confirmDialog.addClass(Puppetry.screenMode).hide();
						EHexDialogUI.messageDialog.addClass(Puppetry.screenMode).hide();
					} else {
						Puppetry.status[Puppetry.screenMode] = controllerId;
					}
					$('.live-content').hide();
					$('.admin-content').hide();
					$('.common-content').hide();
					
					$('.toolbar-container').empty();
					
					var controller = Puppetry.controller[controllerId];
					
					$('.nav.sidebar-nav li.active').removeClass('active');
					$('.nav.sidebar-nav li' + controller._menuItemId).addClass('active');
					
					self.adjustContent();
					
					controller.showUI(source, detail);
				}
			});
		},
		
		showDetailUI : function(source, e) {
			var controllerId = Puppetry.status[Puppetry.screenMode];
			var controller = Puppetry.controller[controllerId];
			
			var detailHeight = $(window).height() - $('.navbar.navbar-default').height();
			$('.detail').css('min-height', detailHeight);
			$('.detail-content').css('min-height', detailHeight - 100);
			
			controller.showDetailUI(source, e);
		},
		
		applyDetailUI : function() {
			var controllerId = Puppetry.status[Puppetry.screenMode];
			var controller = Puppetry.controller[controllerId];
			controller.applyDetailUI();
		},
		
		hideDetailUI : function() {
			var controllerId = Puppetry.status[Puppetry.screenMode];
			var controller = Puppetry.controller[controllerId];
			controller.hideDetailUI();
		},
		
		deleteDetailUI : function(source) {
			var controllerId = Puppetry.status[Puppetry.screenMode];
			var controller = Puppetry.controller[controllerId];
			controller.deleteDetailUI(source);
		},
		
		currentController : function() {
			var controllerId = Puppetry.status[Puppetry.screenMode];
			var controller = Puppetry.controller[controllerId];
			return controller;
		},		
		
		ejectLiveCard : function(event, source) {
			Puppetry.controller['live-client-terminal-ui'].ejectCard(event, source);
		},
		
		navigateToCard : function(source) {
			var card = $(source).closest('.plugged-card,.basic-card');
			var cardId = card.attr('id');
			
			switch (card.attr('type')) {
				case 'EHC':
					Puppetry.toggleMode('admin-mode');
					Puppetry.showUI('admin-ehc-ui', null, cardId);
					break;
				case 'SMCB':
					Puppetry.toggleMode('admin-mode');
					Puppetry.showUI('admin-smcb-ui', null, cardId);
					break;
				default:
					break;
			}
		},
				
		initUI : function() {
			console.log("initUI");
			$.ajaxSetup({ cache: false });
			
			var self = this;
			
			//$('body').hide();
			
			EHexLicenceService.getLicence(
					function(data, textStatus, jqXHR) {
	
						//$('body').show();
						
						$('.feature').hide();
						$('.feature').addClass('feature-hidden');
						if (data && data.features) {
							$.each(data.features, function(key, entry) {
								if (entry.code) {
									$('.feature.feature-' + entry.code.toLowerCase()).removeClass('feature-hidden');
								}
							});
						}
						
						$(document.body).bind("dragover", function(event) {
							event.originalEvent.dataTransfer.dropEffect = "none";
							event.preventDefault();
				            return false;
						});
						

						$(document.body).bind("drop", function(event, ui){	    	   	
							event.preventDefault();
				            return false;
				        });
						
						$.each(Puppetry.controller, function(key, entry) {
							entry.initUI();
						});
						PuppetryInfos.initUI();
						
						$('.date').datepicker({
							 dateFormat: "dd.mm.yy",
							 changeMonth: false,
							 changeYear: false,
							 onClose: function() {
								 $(this).trigger('blur');
							 }
						});
						
						Puppetry.toggleMode('live-mode');
						Puppetry.showUI();	
						//Puppetry.toggleMode('admin-mode');
						//Puppetry.showClients();
						
						$(window).resize(function() {
							self.adjustContent();
						});			
					},
					EHexServiceUtil.onErrorHandler,
					self
				);
			
		},

		showClients : function() {
			Puppetry.showUI('admin-client-ui');
		},
		
		showClientSystemUI : function() {
			Puppetry.showUI('common-connector-clientsystem-authentication-ui');
		},
		
		showClientTerminalUI : function(source) {
			Puppetry.showUI('admin-client-terminal-ui', source);
		},

		showEHCs : function() {
			Puppetry.showUI('admin-ehc-ui');
		},
		
		showSMCBs : function() {
			Puppetry.showUI('admin-smcb-ui');
		},
		
		showConnectorStatusUI : function() {
			Puppetry.showUI('common-connector-status-ui');
		},
		
		showConnectorSettingsUI : function() {
			Puppetry.showUI('common-connector-settings-ui');
		},
		
		showLiveEventUI : function() {
			Puppetry.showUI('live-event-ui');
		},
		
		showConnectorLogUI : function() {
			Puppetry.showUI('common-connector-log-ui');
		},

		showSystemInfoUI : function() {
			Puppetry.showUI('common-systeminfo');
		},
		
		showBackupUI : function() {
			Puppetry.showUI('admin-backup-ui');
		},
		
		showLiveClientUI : function() {
			Puppetry.showUI('live-client-ui');
		},
		
		showLiveClientServiceHookUI : function(source) {
			Puppetry.showUI('live-client-servicehook-ui', source);
		},
		
		showLiveClientTerminalUI : function(source) {
			Puppetry.showUI('live-client-terminal-ui', source);
		},
		
		showLiveProtocolUI : function() {
			var controller = Puppetry.controller['live-protocol-ui'];
			controller.showUI();
		},
		
		showLiveSubscriptionUI : function() {
			Puppetry.showUI('live-subscription-ui');
		},

		showLiveTestCaseSetUI : function() {
			Puppetry.showUI('live-testcase-set-ui');
		},
		
		showLiveTestCaseUI : function(source) {
			Puppetry.showUI('live-testcase-ui', source);
		},
		
		toggleMode : function(screenMode) {
			this.confirmDirty(function(result) {
				if (result) {
					if (!screenMode) {
						screenMode = Puppetry.screenMode;
						if (screenMode == 'live-mode') {
							screenMode = 'admin-mode';
						} else {
							screenMode = 'live-mode'; 
						}
					}
					Puppetry.screenMode = screenMode;
					Puppetry.showUI();
					
					if (screenMode == 'admin-mode') {
						$('#wrapper').removeClass('live-mode').addClass('admin-mode');
						$('.jsPanel-theme-puppetry').removeClass('live-mode').addClass('admin-mode');
						$('.live-mode,.feature-hidden').hide();
						$('.admin-mode:not(.feature-hidden)').show();
						EHexDialogUI.confirmDialog.removeClass('live-mode').addClass('admin-mode').hide();
						EHexDialogUI.messageDialog.removeClass('live-mode').addClass('admin-mode').hide();
					} else {
						$('#wrapper').removeClass('admin-mode').addClass('live-mode');
						$('.jsPanel-theme-puppetry').removeClass('admin-mode').addClass('live-mode');
						$('.admin-mode,.feature-hidden').hide();
						$('.live-mode:not(.feature-hidden)').show();
						EHexDialogUI.confirmDialog.removeClass('admin-mode').addClass('live-mode').hide();
						EHexDialogUI.messageDialog.removeClass('admin-mode').addClass('live-mode').hide();
					}	
				}
			});
		},
		
				
};
